clear
clear matrix
clear mata
set mem 500m
clear
use "C:\file_jmcb_data.dta"

*****************************************************
*Continuous-time duration analysis: Market exit*
*****************************************************

***clear data and generate variables needed***


gen larger_countries=.
replace larger_countries=0 if country_code=="MAR"
replace larger_countries=0 if country_code=="VEN"
replace larger_countries=0 if country_code=="AGO"
replace larger_countries=0 if country_code=="DOM"
replace larger_countries=0 if country_code=="ABW"
replace larger_countries=0 if country_code=="ADO"
replace larger_countries=0 if country_code=="AFG"
replace larger_countries=0 if country_code=="ALB"
replace larger_countries=0 if country_code=="ARE"
replace larger_countries=1 if country_code=="ARG"
replace larger_countries=0 if country_code=="ARM"
replace larger_countries=0 if country_code=="ASM"
replace larger_countries=0 if country_code=="ATG"
replace larger_countries=1 if country_code=="AUS"
replace larger_countries=1 if country_code=="AUT"
replace larger_countries=0 if country_code=="AZE"
replace larger_countries=0 if country_code=="BDI"
replace larger_countries=1 if country_code=="BEL"
replace larger_countries=0 if country_code=="BEN"
replace larger_countries=0 if country_code=="BFA"
replace larger_countries=0 if country_code=="BGD"
replace larger_countries=0 if country_code=="BGR"
replace larger_countries=0 if country_code=="BHR"
replace larger_countries=0 if country_code=="BHS"
replace larger_countries=0 if country_code=="BIH"
replace larger_countries=0 if country_code=="BLR"
replace larger_countries=0 if country_code=="BLZ"
replace larger_countries=0 if country_code=="BMU"
replace larger_countries=0 if country_code=="BOL"
replace larger_countries=1 if country_code=="BRA"
replace larger_countries=0 if country_code=="BRB"
replace larger_countries=0 if country_code=="BRN"
replace larger_countries=0 if country_code=="BTN"
replace larger_countries=0 if country_code=="BWA"
replace larger_countries=0 if country_code=="CAF"
replace larger_countries=1 if country_code=="CAN"
replace larger_countries=1 if country_code=="CHE"
replace larger_countries=0 if country_code=="CHI"
replace larger_countries=0 if country_code=="CHL"
replace larger_countries=1 if country_code=="CHN"
replace larger_countries=0 if country_code=="CIV"
replace larger_countries=0 if country_code=="CMR"
replace larger_countries=0 if country_code=="COG"
replace larger_countries=0 if country_code=="COL"
replace larger_countries=0 if country_code=="COM"
replace larger_countries=0 if country_code=="CPV"
replace larger_countries=0 if country_code=="CRI"
replace larger_countries=0 if country_code=="CUB"
replace larger_countries=0 if country_code=="CYM"
replace larger_countries=0 if country_code=="CYP"
replace larger_countries=0 if country_code=="CZE"
replace larger_countries=1 if country_code=="DEU"
replace larger_countries=0 if country_code=="DJI"
replace larger_countries=0 if country_code=="DMA"
replace larger_countries=1 if country_code=="DNK"
replace larger_countries=0 if country_code=="DZA"
replace larger_countries=0 if country_code=="ECU"
replace larger_countries=0 if country_code=="EGY"
replace larger_countries=0 if country_code=="ERI"
replace larger_countries=1 if country_code=="ESP"
replace larger_countries=0 if country_code=="EST"
replace larger_countries=0 if country_code=="ETH"
replace larger_countries=0 if country_code=="FIN"
replace larger_countries=0 if country_code=="FJI"
replace larger_countries=1 if country_code=="FRA"
replace larger_countries=0 if country_code=="FRO"
replace larger_countries=0 if country_code=="FSM"
replace larger_countries=0 if country_code=="GAB"
replace larger_countries=1 if country_code=="GBR"
replace larger_countries=0 if country_code=="GEO"
replace larger_countries=0 if country_code=="GHA"
replace larger_countries=0 if country_code=="GIN"
replace larger_countries=0 if country_code=="GMB"
replace larger_countries=0 if country_code=="GNB"
replace larger_countries=0 if country_code=="GNQ"
replace larger_countries=0 if country_code=="GRC"
replace larger_countries=0 if country_code=="GRD"
replace larger_countries=0 if country_code=="GRL"
replace larger_countries=0 if country_code=="GTM"
replace larger_countries=0 if country_code=="GUM"
replace larger_countries=0 if country_code=="GUY"
replace larger_countries=0 if country_code=="HKG"
replace larger_countries=0 if country_code=="HND"
replace larger_countries=0 if country_code=="HRV"
replace larger_countries=0 if country_code=="HTI"
replace larger_countries=0 if country_code=="HUN"
replace larger_countries=1 if country_code=="IDN"
replace larger_countries=0 if country_code=="IMY"
replace larger_countries=1 if country_code=="IND"
replace larger_countries=0 if country_code=="IRL"
replace larger_countries=1 if country_code=="IRN"
replace larger_countries=0 if country_code=="IRQ"
replace larger_countries=0 if country_code=="ISL"
replace larger_countries=0 if country_code=="ISR"
replace larger_countries=1 if country_code=="ITA"
replace larger_countries=0 if country_code=="JAM"
replace larger_countries=0 if country_code=="JOR"
replace larger_countries=1 if country_code=="JPN"
replace larger_countries=0 if country_code=="KAZ"
replace larger_countries=0 if country_code=="KEN"
replace larger_countries=0 if country_code=="KGZ"
replace larger_countries=0 if country_code=="KHM"
replace larger_countries=0 if country_code=="KIR"
replace larger_countries=0 if country_code=="KNA"
replace larger_countries=1 if country_code=="KOR"
replace larger_countries=0 if country_code=="KSV"
replace larger_countries=0 if country_code=="KWT"
replace larger_countries=0 if country_code=="LAO"
replace larger_countries=0 if country_code=="LBN"
replace larger_countries=0 if country_code=="LBR"
replace larger_countries=0 if country_code=="LBY"
replace larger_countries=0 if country_code=="LCA"
replace larger_countries=0 if country_code=="LIE"
replace larger_countries=0 if country_code=="LKA"
replace larger_countries=0 if country_code=="LSO"
replace larger_countries=0 if country_code=="LTU"
replace larger_countries=0 if country_code=="LUX"
replace larger_countries=0 if country_code=="LVA"
replace larger_countries=0 if country_code=="MAC"
replace larger_countries=0 if country_code=="MCO"
replace larger_countries=0 if country_code=="MDA"
replace larger_countries=0 if country_code=="MDG"
replace larger_countries=0 if country_code=="MDV"
replace larger_countries=1 if country_code=="MEX"
replace larger_countries=0 if country_code=="MHL"
replace larger_countries=0 if country_code=="MKD"
replace larger_countries=0 if country_code=="MLI"
replace larger_countries=0 if country_code=="MLT"
replace larger_countries=0 if country_code=="MMR"
replace larger_countries=0 if country_code=="MNE"
replace larger_countries=0 if country_code=="MNG"
replace larger_countries=0 if country_code=="MNP"
replace larger_countries=0 if country_code=="MOZ"
replace larger_countries=0 if country_code=="MRT"
replace larger_countries=0 if country_code=="MUS"
replace larger_countries=0 if country_code=="MWI"
replace larger_countries=0 if country_code=="MYS"
replace larger_countries=0 if country_code=="NAM"
replace larger_countries=0 if country_code=="NCL"
replace larger_countries=0 if country_code=="NER"
replace larger_countries=0 if country_code=="NGA"
replace larger_countries=0 if country_code=="NIC"
replace larger_countries=1 if country_code=="NLD"
replace larger_countries=1 if country_code=="NOR"
replace larger_countries=0 if country_code=="NPL"
replace larger_countries=0 if country_code=="NZL"
replace larger_countries=0 if country_code=="OMN"
replace larger_countries=0 if country_code=="PAK"
replace larger_countries=0 if country_code=="PAN"
replace larger_countries=0 if country_code=="PER"
replace larger_countries=0 if country_code=="PHL"
replace larger_countries=0 if country_code=="PLW"
replace larger_countries=0 if country_code=="PNG"
replace larger_countries=1 if country_code=="POL"
replace larger_countries=0 if country_code=="PRI"
replace larger_countries=0 if country_code=="PRK"
replace larger_countries=0 if country_code=="PRT"
replace larger_countries=0 if country_code=="PRY"
replace larger_countries=0 if country_code=="PYF"
replace larger_countries=0 if country_code=="QAT"
replace larger_countries=0 if country_code=="ROM"
replace larger_countries=1 if country_code=="RUS"
replace larger_countries=0 if country_code=="RWA"
replace larger_countries=1 if country_code=="SAU"
replace larger_countries=0 if country_code=="SDN"
replace larger_countries=0 if country_code=="SEN"
replace larger_countries=0 if country_code=="SGP"
replace larger_countries=0 if country_code=="SLB"
replace larger_countries=0 if country_code=="SLE"
replace larger_countries=0 if country_code=="SLV"
replace larger_countries=0 if country_code=="SMR"
replace larger_countries=0 if country_code=="SOM"
replace larger_countries=0 if country_code=="SRB"
replace larger_countries=0 if country_code=="STP"
replace larger_countries=0 if country_code=="SUR"
replace larger_countries=0 if country_code=="SVK"
replace larger_countries=0 if country_code=="SVN"
replace larger_countries=1 if country_code=="SWE"
replace larger_countries=0 if country_code=="SWZ"
replace larger_countries=0 if country_code=="SYC"
replace larger_countries=0 if country_code=="SYR"
replace larger_countries=0 if country_code=="TCA"
replace larger_countries=0 if country_code=="TCD"
replace larger_countries=0 if country_code=="TGO"
replace larger_countries=0 if country_code=="THA"
replace larger_countries=0 if country_code=="TJK"
replace larger_countries=0 if country_code=="TKM"
replace larger_countries=0 if country_code=="TMP"
replace larger_countries=0 if country_code=="TON"
replace larger_countries=0 if country_code=="TTO"
replace larger_countries=0 if country_code=="TUN"
replace larger_countries=1 if country_code=="TUR"
replace larger_countries=0 if country_code=="TUV"
replace larger_countries=0 if country_code=="TZA"
replace larger_countries=0 if country_code=="UGA"
replace larger_countries=0 if country_code=="UKR"
replace larger_countries=0 if country_code=="URY"
replace larger_countries=1 if country_code=="USA"
replace larger_countries=0 if country_code=="UZB"
replace larger_countries=0 if country_code=="VCT"
replace larger_countries=0 if country_code=="VIR"
replace larger_countries=0 if country_code=="VNM"
replace larger_countries=0 if country_code=="VUT"
replace larger_countries=0 if country_code=="WBG"
replace larger_countries=0 if country_code=="WSM"
replace larger_countries=0 if country_code=="YEM"
replace larger_countries=1 if country_code=="ZAF"
replace larger_countries=0 if country_code=="ZAR"
replace larger_countries=0 if country_code=="ZMB"
replace larger_countries=0 if country_code=="ZWE"



gen lenght_above=.
replace lenght_above=0 if country_code=="MAR"
replace lenght_above=0 if country_code=="VEN"
replace lenght_above=1 if country_code=="AGO"
replace lenght_above=1 if country_code=="DOM"
replace lenght_above=0 if country_code=="ALB"
replace lenght_above=0 if country_code=="ARG"
replace lenght_above=1 if country_code=="BFA"
replace lenght_above=0 if country_code=="BGR"
replace lenght_above=1 if country_code=="BOL"
replace lenght_above=1 if country_code=="BRA"
replace lenght_above=1 if country_code=="CAF"
replace lenght_above=0 if country_code=="CHL"
replace lenght_above=1 if country_code=="CMR"
replace lenght_above=0 if country_code=="COL"
replace lenght_above=1 if country_code=="CPV"
replace lenght_above=0 if country_code=="CRI"
replace lenght_above=0 if country_code=="DMA"
replace lenght_above=0 if country_code=="DZA"
replace lenght_above=0 if country_code=="ECU"
replace lenght_above=1 if country_code=="ETH"
replace lenght_above=0 if country_code=="GAB"
replace lenght_above=0 if country_code=="GIN"
replace lenght_above=0 if country_code=="GMB"
replace lenght_above=1 if country_code=="GNB"
replace lenght_above=0 if country_code=="GTM"
replace lenght_above=1 if country_code=="GUY"
replace lenght_above=1 if country_code=="HND"
replace lenght_above=0 if country_code=="HRV"
replace lenght_above=1 if country_code=="HTI"
replace lenght_above=0 if country_code=="JAM"
replace lenght_above=0 if country_code=="JOR"
replace lenght_above=1 if country_code=="KEN"
replace lenght_above=0 if country_code=="LKA"
replace lenght_above=0 if country_code=="MDA"
replace lenght_above=1 if country_code=="MDG"
replace lenght_above=0 if country_code=="MEX"
replace lenght_above=0 if country_code=="MKD"
replace lenght_above=0 if country_code=="MMR"
replace lenght_above=0 if country_code=="MNG"
replace lenght_above=1 if country_code=="MOZ"
replace lenght_above=0 if country_code=="MRT"
replace lenght_above=0 if country_code=="NER"
replace lenght_above=0 if country_code=="NGA"
replace lenght_above=1 if country_code=="NIC"
replace lenght_above=0 if country_code=="PAK"
replace lenght_above=1 if country_code=="PAN"
replace lenght_above=0 if country_code=="PER"
replace lenght_above=1 if country_code=="PHL"
replace lenght_above=1 if country_code=="POL"
replace lenght_above=0 if country_code=="PRY"
replace lenght_above=0 if country_code=="ROM"
replace lenght_above=0 if country_code=="RUS"
replace lenght_above=0 if country_code=="RWA"
replace lenght_above=0 if country_code=="SEN"
replace lenght_above=0 if country_code=="SLB"
replace lenght_above=0 if country_code=="SLE"
replace lenght_above=1 if country_code=="SLV"
replace lenght_above=1 if country_code=="SRB"
replace lenght_above=0 if country_code=="STP"
replace lenght_above=0 if country_code=="SYC"
replace lenght_above=0 if country_code=="TGO"
replace lenght_above=0 if country_code=="THA"
replace lenght_above=0 if country_code=="TTO"
replace lenght_above=1 if country_code=="TZA"
replace lenght_above=1 if country_code=="UGA"
replace lenght_above=0 if country_code=="UKR"
replace lenght_above=0 if country_code=="URY"
replace lenght_above=1 if country_code=="VNM"
replace lenght_above=1 if country_code=="YEM"
replace lenght_above=0 if country_code=="ZAF"
replace lenght_above=1 if country_code=="ZMB"
replace lenght_above=0 if country_code=="ZWE"


gen haircut_above=.
replace haircut_above=1 if country_code=="MAR"
replace haircut_above=0 if country_code=="VEN"
replace haircut_above=1 if country_code=="AGO"
replace haircut_above=1 if country_code=="DOM"
replace haircut_above=0 if country_code=="ALB"
replace haircut_above=1 if country_code=="ARG"
replace haircut_above=1 if country_code=="BFA"
replace haircut_above=1 if country_code=="BGR"
replace haircut_above=1 if country_code=="BOL"
replace haircut_above=0 if country_code=="BRA"
replace haircut_above=1 if country_code=="CAF"
replace haircut_above=1 if country_code=="CHL"
replace haircut_above=1 if country_code=="CMR"
replace haircut_above=0 if country_code=="COL"
replace haircut_above=1 if country_code=="CPV"
replace haircut_above=1 if country_code=="CRI"
replace haircut_above=0 if country_code=="DMA"
replace haircut_above=0 if country_code=="DZA"
replace haircut_above=0 if country_code=="ECU"
replace haircut_above=1 if country_code=="ETH"
replace haircut_above=1 if country_code=="GAB"
replace haircut_above=0 if country_code=="GIN"
replace haircut_above=1 if country_code=="GMB"
replace haircut_above=1 if country_code=="GNB"
replace haircut_above=0 if country_code=="GTM"
replace haircut_above=1 if country_code=="GUY"
replace haircut_above=1 if country_code=="HND"
replace haircut_above=0 if country_code=="HRV"
replace haircut_above=1 if country_code=="HTI"
replace haircut_above=1 if country_code=="JAM"
replace haircut_above=1 if country_code=="JOR"
replace haircut_above=1 if country_code=="KEN"
replace haircut_above=0 if country_code=="LKA"
replace haircut_above=0 if country_code=="MDA"
replace haircut_above=1 if country_code=="MDG"
replace haircut_above=0 if country_code=="MEX"
replace haircut_above=1 if country_code=="MKD"
replace haircut_above=1 if country_code=="MMR"
replace haircut_above=0 if country_code=="MNG"
replace haircut_above=1 if country_code=="MOZ"
replace haircut_above=1 if country_code=="MRT"
replace haircut_above=1 if country_code=="NER"
replace haircut_above=0 if country_code=="NGA"
replace haircut_above=1 if country_code=="NIC"
replace haircut_above=0 if country_code=="PAK"
replace haircut_above=0 if country_code=="PAN"
replace haircut_above=0 if country_code=="PER"
replace haircut_above=0 if country_code=="PHL"
replace haircut_above=1 if country_code=="POL"
replace haircut_above=0 if country_code=="PRY"
replace haircut_above=0 if country_code=="ROM"
replace haircut_above=0 if country_code=="RUS"
replace haircut_above=0 if country_code=="RWA"
replace haircut_above=0 if country_code=="SEN"
replace haircut_above=1 if country_code=="SLB"
replace haircut_above=1 if country_code=="SLE"
replace haircut_above=1 if country_code=="SLV"
replace haircut_above=1 if country_code=="SRB"
replace haircut_above=1 if country_code=="STP"
replace haircut_above=0 if country_code=="SYC"
replace haircut_above=1 if country_code=="TGO"
replace haircut_above=0 if country_code=="THA"
replace haircut_above=0 if country_code=="TTO"
replace haircut_above=1 if country_code=="TZA"
replace haircut_above=1 if country_code=="UGA"
replace haircut_above=0 if country_code=="UKR"
replace haircut_above=0 if country_code=="URY"
replace haircut_above=1 if country_code=="VNM"
replace haircut_above=0 if country_code=="YEM"
replace haircut_above=0 if country_code=="ZAF"
replace haircut_above=1 if country_code=="ZMB"
replace haircut_above=0 if country_code=="ZWE"



g sum_default_history =.

forv i=1(1)210 {

egen sum_default_history_`i'=sum(default_history) if id==`i'

replace sum_default_history=sum_default_history_`i' if id==`i'

drop sum_default_history_`i'

}

replace sum_default_history =. if default_history==.


list id sum_default_history if sum_default_history==0
gen d_default_history=.
replace d_default_history =0 if sum_default_history<1
replace d_default_history =1 if sum_default_history>0 & sum_default_history~=.

sum sum_default_history d_default_history

*drop sum_default_history


g sum_imf_prog =.

forv i=1(1)210 {

egen sum_imf_prog_`i'=sum(imf_prog) if id==`i'

replace sum_imf_prog=sum_imf_prog_`i' if id==`i'

drop sum_imf_prog_`i'

}

replace sum_imf_prog =. if imf_prog==.

gen d_imf_prog=.
replace d_imf_prog =0 if sum_imf_prog<1
replace d_imf_prog =1 if sum_imf_prog>0 & sum_imf_prog~=.


sum yeconomicriskrating 
gen d_eco_risk=.
replace d_eco_risk=0 if yeconomicriskrating<33.66 & yeconomicriskrating~=.
replace d_eco_risk=1 if yeconomicriskrating>=33.66 & yeconomicriskrating~=.
sum yeconomicriskrating d_eco_risk

sum yfinancialriskrating  
gen d_fin_risk=.
replace d_fin_risk=0 if yfinancialriskrating <34.43 & yfinancialriskrating ~=.
replace d_fin_risk=1 if yfinancialriskrating >=34.43 & yfinancialriskrating ~=.
sum yfinancialriskrating  d_fin_risk

sum ypoliticalriskrating  
gen d_pol_risk=.
replace d_pol_risk=0 if ypoliticalriskrating <64.11 & ypoliticalriskrating ~=.
replace d_pol_risk=1 if ypoliticalriskrating >=64.11 & ypoliticalriskrating ~=.
sum ypoliticalriskrating  d_pol_risk




*keep data for duration analysis


keep if mkt_exit~=.
keep if  mkt_exit~=0
keep if _end_x==1

sort id
by id: gen event_x=_n

sum dur_mkt_exit censor_x event_x dur_prev_r

*list
tab dur_mkt_exit censor_x
list dur_mkt_exit censor_x id

***stset the data for duration analysis***
***and descriptive statistics***

sum dur_mkt_exit censor_x event_x dur_prev_r oecd ///
 apac latin middle africa europe northamerica
sum dur_mkt_exit if oecd==0
sum dur_mkt_exit if oecd==1



****************************************************************
*Simple Weibull: h(t)= gamma*p*t^(p-1)*
****************************************************************
*MKT exit

stset dur_mkt_exit, failure(censor_x)
des dur_mkt_exit censor_x event_x dur_prev_r
sum dur_mkt_exit censor_x event_x dur_prev_r
list dur_mkt_exit censor_x event_x dur_prev_r id
sts list
stsum
tab dur_mkt_exit censor_x

ltable dur_mkt_exit censor_x, survival noadjust ci 

*
*sort dur_mkt_exit
*by dur_mkt_exit: sum id
*

*Table 2
*********
streg, dist(weibull) nohr vce(cluster id)
estat ic
*constant (it is the "gamma" in the model; see also JBES paper)
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2


*regional and decades effects
*****************************
streg apac latin middle africa europe dec70 dec80 dec90, dist(weibull) nohr vce(cluster id)
estat ic
*constant
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2


*regressors
**************

streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_x dur_prev_r, ///
 dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2


streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_x dur_prev_r d_default_history imf_prog larger_countries, ///
 dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2


streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk, ///
 dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2

 
  


*change-points

*Table 4
********

gen ddur12=0
replace ddur12=1 if dur_mkt_exit>=12

streg ddur12, dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])
nlcom _b[p]-1
nlcom _b[p]-2

streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk, ///
 dist(weibull) frailty(invgaussian) nohr vce(cluster id)

************

program define my_weibull_x
	version 9
	args lnf theta1 theta2 theta3
	quietly replace `lnf' = $ML_y2*((1-ddur12)* ///
	ln(`theta3'/$ML_y1)+ddur12*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12)))) + ///
	(1-ddur12)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur12*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12)))) - ///
	exp((1-ddur12)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur12*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12))))
end


*1.basic
ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p, vce(cluster id)
ml maximize
estat ic

nlcom _b[/eq1]-_b[/eq2]
nlcom ln(_b[/eq1])
nlcom ln(_b[/eq2])
nlcom ln(_b[/eq1])-ln(_b[/eq2])
nlcom (_b[/eq1])^(_b[/p])
nlcom (_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(12))/(ln(_b[/eq2])+ln(12))))
nlcom (_b[/eq1])^(_b[/p])-(_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(12))/(ln(_b[/eq2])+ln(12))))
nlcom ln((_b[/eq1])^(_b[/p]))
nlcom ln((_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(12))/(ln(_b[/eq2])+ln(12)))))
nlcom (_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(12))/(ln(_b[/eq2])+ln(12)))) - (_b[/eq1])^(_b[/p])
nlcom _b[/p]-1
nlcom _b[/p]-2
nlcom ln(_b[/p])
nlcom ln(_b[/p])-ln2
nlcom 1/_b[/p]

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-1
nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-2
nlcom ln(_b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12))))
nlcom ln(_b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12))))-ln(2)

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]

nlcom ln(_b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12))))-ln(_b[/p])

nlcom _b[/p]*(((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-1)

nlcom ((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(1o)))-1

program drop my_weibull_x


**with regressors

program define my_weibull_x
	version 9
	args lnf theta1 theta2 theta3 theta4
	quietly replace `lnf' = $ML_y2*(`theta4'+(1-ddur12)* ///
	ln(`theta3'/$ML_y1)+ddur12*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12)))) + ///
	(1-ddur12)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur12*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12)))) - ///
	exp(`theta4'+(1-ddur12)*`theta3'*ln(`theta1'*$ML_y1) + ///
	ddur12*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12))))
end




ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


*intermedium resuts chg point
*****************************

gen ddur12=0
replace ddur12=1 if dur_mkt_exit>=12


program drop my_weibull_x


program define my_weibull_x
	version 9
	args lnf theta1 theta2 theta3 theta4
	quietly replace `lnf' = $ML_y2*(`theta4'+(1-ddur12)* ///
	ln(`theta3'/$ML_y1)+ddur12*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12)))) + ///
	(1-ddur12)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur12*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12)))) - ///
	exp(`theta4'+(1-ddur12)*`theta3'*ln(`theta1'*$ML_y1) + ///
	ddur12*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*12))/(ln(`theta2'*12))))
end




ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_xregm, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append



ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_xregm, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append



ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_xregm, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append




*********
*********
*Tables 5 & 6
*sens
ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if id~=47, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if id~=47 & id~=141 & id~=142, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if oecd==0, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out2, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if d_default_history~=0, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]

outreg2 using table_out2, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r lenght_above imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out3, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r haircut_above imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out3, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk d_bank_crises), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out4, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk crisis_tally), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]

outreg2 using table_out4, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk d_cap100), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out4, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append






ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk d_banking), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(12))/(ln(_b[/eq2])+ln(12)))-_b[/p]


outreg2 using table_out4_bk, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append



outreg2 using table_out, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append




******************************************************************
******************************************************************
*Experiments for Figure 1

gen ddur6=0
replace ddur6=1 if dur_mkt_exit>=6

program drop my_weibull_x


program define my_weibull_x
	version 11
	args lnf theta1 theta2 theta3 theta4
	quietly replace `lnf' = $ML_y2*(`theta4'+(1-ddur6)* ///
	ln(`theta3'/$ML_y1)+ddur6*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*6))/(ln(`theta2'*6)))) + ///
	(1-ddur6)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur6*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*6))/(ln(`theta2'*6)))) - ///
	exp(`theta4'+(1-ddur6)*`theta3'*ln(`theta1'*$ML_y1) + ///
	ddur6*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*6))/(ln(`theta2'*6))))
end




ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec60 dec60 dec60 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(6))/(ln(_b[/eq2])+ln(6)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(6))/(ln(_b[/eq2])+ln(6)))-_b[/p]




******************************************************************
******************************************************************

gen ddur11=0
replace ddur11=1 if dur_mkt_exit>=11

program drop my_weibull_x


program define my_weibull_x
	version 14
	args lnf theta1 theta2 theta3
	quietly replace `lnf' = $ML_y2*((1-ddur11)* ///
	ln(`theta3'/$ML_y1)+ddur11*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*11))/(ln(`theta2'*11)))) + ///
	(1-ddur11)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur11*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*11))/(ln(`theta2'*11)))) - ///
	exp((1-ddur11)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur11*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*11))/(ln(`theta2'*11))))
end


ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p, vce(cluster id)
ml maximize
estat ic


nlcom _b[/p]*((ln(_b[/eq1])+ln(11))/(ln(_b[/eq2])+ln(11)))


nlcom _b[/p]*((ln(_b[/eq1])+ln(11))/(ln(_b[/eq2])+ln(11)))-_b[/p]




program drop my_weibull_x


program define my_weibull_x
	version 14
	args lnf theta1 theta2 theta3 theta4
	quietly replace `lnf' = $ML_y2*(`theta4'+(1-ddur11)* ///
	ln(`theta3'/$ML_y1)+ddur11*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*11))/(ln(`theta2'*11)))) + ///
	(1-ddur11)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur11*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*11))/(ln(`theta2'*11)))) - ///
	exp(`theta4'+(1-ddur11)*`theta3'*ln(`theta1'*$ML_y1) + ///
	ddur11*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*11))/(ln(`theta2'*11))))
end




ml model lf my_weibull_x (dur_mkt_exit censor_x = ) ///
	(dur_mkt_exit censor_x = ) /p (dur_mkt_exit censor_x = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_x dur_prev_r d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(dfp)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(11))/(ln(_b[/eq2])+ln(11)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(11))/(ln(_b[/eq2])+ln(11)))-_b[/p]





*Figure 1
ltable dur_mkt_exit censor_x, graph ///
					     survival noadjust ///
					     title("Survival function: market exit") ///
					     xtitle("Survival time") ///
					     xtick(0(1)45) xlabel(0(5)45) ///
					     ylabel(0(0.25)1) ci







*****************************************************
*Continuous-time duration analysis: MARKET Re-entry*
*****************************************************
clear
use "C:\file_jmcb_data.dta"


***keep just data for continuous time analysis***


gen larger_countries=.
replace larger_countries=0 if country_code=="MAR"
replace larger_countries=0 if country_code=="VEN"
replace larger_countries=0 if country_code=="AGO"
replace larger_countries=0 if country_code=="DOM"
replace larger_countries=0 if country_code=="ABW"
replace larger_countries=0 if country_code=="ADO"
replace larger_countries=0 if country_code=="AFG"
replace larger_countries=0 if country_code=="ALB"
replace larger_countries=0 if country_code=="ARE"
replace larger_countries=1 if country_code=="ARG"
replace larger_countries=0 if country_code=="ARM"
replace larger_countries=0 if country_code=="ASM"
replace larger_countries=0 if country_code=="ATG"
replace larger_countries=1 if country_code=="AUS"
replace larger_countries=1 if country_code=="AUT"
replace larger_countries=0 if country_code=="AZE"
replace larger_countries=0 if country_code=="BDI"
replace larger_countries=1 if country_code=="BEL"
replace larger_countries=0 if country_code=="BEN"
replace larger_countries=0 if country_code=="BFA"
replace larger_countries=0 if country_code=="BGD"
replace larger_countries=0 if country_code=="BGR"
replace larger_countries=0 if country_code=="BHR"
replace larger_countries=0 if country_code=="BHS"
replace larger_countries=0 if country_code=="BIH"
replace larger_countries=0 if country_code=="BLR"
replace larger_countries=0 if country_code=="BLZ"
replace larger_countries=0 if country_code=="BMU"
replace larger_countries=0 if country_code=="BOL"
replace larger_countries=1 if country_code=="BRA"
replace larger_countries=0 if country_code=="BRB"
replace larger_countries=0 if country_code=="BRN"
replace larger_countries=0 if country_code=="BTN"
replace larger_countries=0 if country_code=="BWA"
replace larger_countries=0 if country_code=="CAF"
replace larger_countries=1 if country_code=="CAN"
replace larger_countries=1 if country_code=="CHE"
replace larger_countries=0 if country_code=="CHI"
replace larger_countries=0 if country_code=="CHL"
replace larger_countries=1 if country_code=="CHN"
replace larger_countries=0 if country_code=="CIV"
replace larger_countries=0 if country_code=="CMR"
replace larger_countries=0 if country_code=="COG"
replace larger_countries=0 if country_code=="COL"
replace larger_countries=0 if country_code=="COM"
replace larger_countries=0 if country_code=="CPV"
replace larger_countries=0 if country_code=="CRI"
replace larger_countries=0 if country_code=="CUB"
replace larger_countries=0 if country_code=="CYM"
replace larger_countries=0 if country_code=="CYP"
replace larger_countries=0 if country_code=="CZE"
replace larger_countries=1 if country_code=="DEU"
replace larger_countries=0 if country_code=="DJI"
replace larger_countries=0 if country_code=="DMA"
replace larger_countries=1 if country_code=="DNK"
replace larger_countries=0 if country_code=="DZA"
replace larger_countries=0 if country_code=="ECU"
replace larger_countries=0 if country_code=="EGY"
replace larger_countries=0 if country_code=="ERI"
replace larger_countries=1 if country_code=="ESP"
replace larger_countries=0 if country_code=="EST"
replace larger_countries=0 if country_code=="ETH"
replace larger_countries=0 if country_code=="FIN"
replace larger_countries=0 if country_code=="FJI"
replace larger_countries=1 if country_code=="FRA"
replace larger_countries=0 if country_code=="FRO"
replace larger_countries=0 if country_code=="FSM"
replace larger_countries=0 if country_code=="GAB"
replace larger_countries=1 if country_code=="GBR"
replace larger_countries=0 if country_code=="GEO"
replace larger_countries=0 if country_code=="GHA"
replace larger_countries=0 if country_code=="GIN"
replace larger_countries=0 if country_code=="GMB"
replace larger_countries=0 if country_code=="GNB"
replace larger_countries=0 if country_code=="GNQ"
replace larger_countries=0 if country_code=="GRC"
replace larger_countries=0 if country_code=="GRD"
replace larger_countries=0 if country_code=="GRL"
replace larger_countries=0 if country_code=="GTM"
replace larger_countries=0 if country_code=="GUM"
replace larger_countries=0 if country_code=="GUY"
replace larger_countries=0 if country_code=="HKG"
replace larger_countries=0 if country_code=="HND"
replace larger_countries=0 if country_code=="HRV"
replace larger_countries=0 if country_code=="HTI"
replace larger_countries=0 if country_code=="HUN"
replace larger_countries=1 if country_code=="IDN"
replace larger_countries=0 if country_code=="IMY"
replace larger_countries=1 if country_code=="IND"
replace larger_countries=0 if country_code=="IRL"
replace larger_countries=1 if country_code=="IRN"
replace larger_countries=0 if country_code=="IRQ"
replace larger_countries=0 if country_code=="ISL"
replace larger_countries=0 if country_code=="ISR"
replace larger_countries=1 if country_code=="ITA"
replace larger_countries=0 if country_code=="JAM"
replace larger_countries=0 if country_code=="JOR"
replace larger_countries=1 if country_code=="JPN"
replace larger_countries=0 if country_code=="KAZ"
replace larger_countries=0 if country_code=="KEN"
replace larger_countries=0 if country_code=="KGZ"
replace larger_countries=0 if country_code=="KHM"
replace larger_countries=0 if country_code=="KIR"
replace larger_countries=0 if country_code=="KNA"
replace larger_countries=1 if country_code=="KOR"
replace larger_countries=0 if country_code=="KSV"
replace larger_countries=0 if country_code=="KWT"
replace larger_countries=0 if country_code=="LAO"
replace larger_countries=0 if country_code=="LBN"
replace larger_countries=0 if country_code=="LBR"
replace larger_countries=0 if country_code=="LBY"
replace larger_countries=0 if country_code=="LCA"
replace larger_countries=0 if country_code=="LIE"
replace larger_countries=0 if country_code=="LKA"
replace larger_countries=0 if country_code=="LSO"
replace larger_countries=0 if country_code=="LTU"
replace larger_countries=0 if country_code=="LUX"
replace larger_countries=0 if country_code=="LVA"
replace larger_countries=0 if country_code=="MAC"
replace larger_countries=0 if country_code=="MCO"
replace larger_countries=0 if country_code=="MDA"
replace larger_countries=0 if country_code=="MDG"
replace larger_countries=0 if country_code=="MDV"
replace larger_countries=1 if country_code=="MEX"
replace larger_countries=0 if country_code=="MHL"
replace larger_countries=0 if country_code=="MKD"
replace larger_countries=0 if country_code=="MLI"
replace larger_countries=0 if country_code=="MLT"
replace larger_countries=0 if country_code=="MMR"
replace larger_countries=0 if country_code=="MNE"
replace larger_countries=0 if country_code=="MNG"
replace larger_countries=0 if country_code=="MNP"
replace larger_countries=0 if country_code=="MOZ"
replace larger_countries=0 if country_code=="MRT"
replace larger_countries=0 if country_code=="MUS"
replace larger_countries=0 if country_code=="MWI"
replace larger_countries=0 if country_code=="MYS"
replace larger_countries=0 if country_code=="NAM"
replace larger_countries=0 if country_code=="NCL"
replace larger_countries=0 if country_code=="NER"
replace larger_countries=0 if country_code=="NGA"
replace larger_countries=0 if country_code=="NIC"
replace larger_countries=1 if country_code=="NLD"
replace larger_countries=1 if country_code=="NOR"
replace larger_countries=0 if country_code=="NPL"
replace larger_countries=0 if country_code=="NZL"
replace larger_countries=0 if country_code=="OMN"
replace larger_countries=0 if country_code=="PAK"
replace larger_countries=0 if country_code=="PAN"
replace larger_countries=0 if country_code=="PER"
replace larger_countries=0 if country_code=="PHL"
replace larger_countries=0 if country_code=="PLW"
replace larger_countries=0 if country_code=="PNG"
replace larger_countries=1 if country_code=="POL"
replace larger_countries=0 if country_code=="PRI"
replace larger_countries=0 if country_code=="PRK"
replace larger_countries=0 if country_code=="PRT"
replace larger_countries=0 if country_code=="PRY"
replace larger_countries=0 if country_code=="PYF"
replace larger_countries=0 if country_code=="QAT"
replace larger_countries=0 if country_code=="ROM"
replace larger_countries=1 if country_code=="RUS"
replace larger_countries=0 if country_code=="RWA"
replace larger_countries=1 if country_code=="SAU"
replace larger_countries=0 if country_code=="SDN"
replace larger_countries=0 if country_code=="SEN"
replace larger_countries=0 if country_code=="SGP"
replace larger_countries=0 if country_code=="SLB"
replace larger_countries=0 if country_code=="SLE"
replace larger_countries=0 if country_code=="SLV"
replace larger_countries=0 if country_code=="SMR"
replace larger_countries=0 if country_code=="SOM"
replace larger_countries=0 if country_code=="SRB"
replace larger_countries=0 if country_code=="STP"
replace larger_countries=0 if country_code=="SUR"
replace larger_countries=0 if country_code=="SVK"
replace larger_countries=0 if country_code=="SVN"
replace larger_countries=1 if country_code=="SWE"
replace larger_countries=0 if country_code=="SWZ"
replace larger_countries=0 if country_code=="SYC"
replace larger_countries=0 if country_code=="SYR"
replace larger_countries=0 if country_code=="TCA"
replace larger_countries=0 if country_code=="TCD"
replace larger_countries=0 if country_code=="TGO"
replace larger_countries=0 if country_code=="THA"
replace larger_countries=0 if country_code=="TJK"
replace larger_countries=0 if country_code=="TKM"
replace larger_countries=0 if country_code=="TMP"
replace larger_countries=0 if country_code=="TON"
replace larger_countries=0 if country_code=="TTO"
replace larger_countries=0 if country_code=="TUN"
replace larger_countries=1 if country_code=="TUR"
replace larger_countries=0 if country_code=="TUV"
replace larger_countries=0 if country_code=="TZA"
replace larger_countries=0 if country_code=="UGA"
replace larger_countries=0 if country_code=="UKR"
replace larger_countries=0 if country_code=="URY"
replace larger_countries=1 if country_code=="USA"
replace larger_countries=0 if country_code=="UZB"
replace larger_countries=0 if country_code=="VCT"
replace larger_countries=0 if country_code=="VIR"
replace larger_countries=0 if country_code=="VNM"
replace larger_countries=0 if country_code=="VUT"
replace larger_countries=0 if country_code=="WBG"
replace larger_countries=0 if country_code=="WSM"
replace larger_countries=0 if country_code=="YEM"
replace larger_countries=1 if country_code=="ZAF"
replace larger_countries=0 if country_code=="ZAR"
replace larger_countries=0 if country_code=="ZMB"
replace larger_countries=0 if country_code=="ZWE"



gen lenght_above=.
replace lenght_above=0 if country_code=="MAR"
replace lenght_above=0 if country_code=="VEN"
replace lenght_above=1 if country_code=="AGO"
replace lenght_above=1 if country_code=="DOM"
replace lenght_above=0 if country_code=="ALB"
replace lenght_above=0 if country_code=="ARG"
replace lenght_above=1 if country_code=="BFA"
replace lenght_above=0 if country_code=="BGR"
replace lenght_above=1 if country_code=="BOL"
replace lenght_above=1 if country_code=="BRA"
replace lenght_above=1 if country_code=="CAF"
replace lenght_above=0 if country_code=="CHL"
replace lenght_above=1 if country_code=="CMR"
replace lenght_above=0 if country_code=="COL"
replace lenght_above=1 if country_code=="CPV"
replace lenght_above=0 if country_code=="CRI"
replace lenght_above=0 if country_code=="DMA"
replace lenght_above=0 if country_code=="DZA"
replace lenght_above=0 if country_code=="ECU"
replace lenght_above=1 if country_code=="ETH"
replace lenght_above=0 if country_code=="GAB"
replace lenght_above=0 if country_code=="GIN"
replace lenght_above=0 if country_code=="GMB"
replace lenght_above=1 if country_code=="GNB"
replace lenght_above=0 if country_code=="GTM"
replace lenght_above=1 if country_code=="GUY"
replace lenght_above=1 if country_code=="HND"
replace lenght_above=0 if country_code=="HRV"
replace lenght_above=1 if country_code=="HTI"
replace lenght_above=0 if country_code=="JAM"
replace lenght_above=0 if country_code=="JOR"
replace lenght_above=1 if country_code=="KEN"
replace lenght_above=0 if country_code=="LKA"
replace lenght_above=0 if country_code=="MDA"
replace lenght_above=1 if country_code=="MDG"
replace lenght_above=0 if country_code=="MEX"
replace lenght_above=0 if country_code=="MKD"
replace lenght_above=0 if country_code=="MMR"
replace lenght_above=0 if country_code=="MNG"
replace lenght_above=1 if country_code=="MOZ"
replace lenght_above=0 if country_code=="MRT"
replace lenght_above=0 if country_code=="NER"
replace lenght_above=0 if country_code=="NGA"
replace lenght_above=1 if country_code=="NIC"
replace lenght_above=0 if country_code=="PAK"
replace lenght_above=1 if country_code=="PAN"
replace lenght_above=0 if country_code=="PER"
replace lenght_above=1 if country_code=="PHL"
replace lenght_above=1 if country_code=="POL"
replace lenght_above=0 if country_code=="PRY"
replace lenght_above=0 if country_code=="ROM"
replace lenght_above=0 if country_code=="RUS"
replace lenght_above=0 if country_code=="RWA"
replace lenght_above=0 if country_code=="SEN"
replace lenght_above=0 if country_code=="SLB"
replace lenght_above=0 if country_code=="SLE"
replace lenght_above=1 if country_code=="SLV"
replace lenght_above=1 if country_code=="SRB"
replace lenght_above=0 if country_code=="STP"
replace lenght_above=0 if country_code=="SYC"
replace lenght_above=0 if country_code=="TGO"
replace lenght_above=0 if country_code=="THA"
replace lenght_above=0 if country_code=="TTO"
replace lenght_above=1 if country_code=="TZA"
replace lenght_above=1 if country_code=="UGA"
replace lenght_above=0 if country_code=="UKR"
replace lenght_above=0 if country_code=="URY"
replace lenght_above=1 if country_code=="VNM"
replace lenght_above=1 if country_code=="YEM"
replace lenght_above=0 if country_code=="ZAF"
replace lenght_above=1 if country_code=="ZMB"
replace lenght_above=0 if country_code=="ZWE"


gen haircut_above=.
replace haircut_above=1 if country_code=="MAR"
replace haircut_above=0 if country_code=="VEN"
replace haircut_above=1 if country_code=="AGO"
replace haircut_above=1 if country_code=="DOM"
replace haircut_above=0 if country_code=="ALB"
replace haircut_above=1 if country_code=="ARG"
replace haircut_above=1 if country_code=="BFA"
replace haircut_above=1 if country_code=="BGR"
replace haircut_above=1 if country_code=="BOL"
replace haircut_above=0 if country_code=="BRA"
replace haircut_above=1 if country_code=="CAF"
replace haircut_above=1 if country_code=="CHL"
replace haircut_above=1 if country_code=="CMR"
replace haircut_above=0 if country_code=="COL"
replace haircut_above=1 if country_code=="CPV"
replace haircut_above=1 if country_code=="CRI"
replace haircut_above=0 if country_code=="DMA"
replace haircut_above=0 if country_code=="DZA"
replace haircut_above=0 if country_code=="ECU"
replace haircut_above=1 if country_code=="ETH"
replace haircut_above=1 if country_code=="GAB"
replace haircut_above=0 if country_code=="GIN"
replace haircut_above=1 if country_code=="GMB"
replace haircut_above=1 if country_code=="GNB"
replace haircut_above=0 if country_code=="GTM"
replace haircut_above=1 if country_code=="GUY"
replace haircut_above=1 if country_code=="HND"
replace haircut_above=0 if country_code=="HRV"
replace haircut_above=1 if country_code=="HTI"
replace haircut_above=1 if country_code=="JAM"
replace haircut_above=1 if country_code=="JOR"
replace haircut_above=1 if country_code=="KEN"
replace haircut_above=0 if country_code=="LKA"
replace haircut_above=0 if country_code=="MDA"
replace haircut_above=1 if country_code=="MDG"
replace haircut_above=0 if country_code=="MEX"
replace haircut_above=1 if country_code=="MKD"
replace haircut_above=1 if country_code=="MMR"
replace haircut_above=0 if country_code=="MNG"
replace haircut_above=1 if country_code=="MOZ"
replace haircut_above=1 if country_code=="MRT"
replace haircut_above=1 if country_code=="NER"
replace haircut_above=0 if country_code=="NGA"
replace haircut_above=1 if country_code=="NIC"
replace haircut_above=0 if country_code=="PAK"
replace haircut_above=0 if country_code=="PAN"
replace haircut_above=0 if country_code=="PER"
replace haircut_above=0 if country_code=="PHL"
replace haircut_above=1 if country_code=="POL"
replace haircut_above=0 if country_code=="PRY"
replace haircut_above=0 if country_code=="ROM"
replace haircut_above=0 if country_code=="RUS"
replace haircut_above=0 if country_code=="RWA"
replace haircut_above=0 if country_code=="SEN"
replace haircut_above=1 if country_code=="SLB"
replace haircut_above=1 if country_code=="SLE"
replace haircut_above=1 if country_code=="SLV"
replace haircut_above=1 if country_code=="SRB"
replace haircut_above=1 if country_code=="STP"
replace haircut_above=0 if country_code=="SYC"
replace haircut_above=1 if country_code=="TGO"
replace haircut_above=0 if country_code=="THA"
replace haircut_above=0 if country_code=="TTO"
replace haircut_above=1 if country_code=="TZA"
replace haircut_above=1 if country_code=="UGA"
replace haircut_above=0 if country_code=="UKR"
replace haircut_above=0 if country_code=="URY"
replace haircut_above=1 if country_code=="VNM"
replace haircut_above=0 if country_code=="YEM"
replace haircut_above=0 if country_code=="ZAF"
replace haircut_above=1 if country_code=="ZMB"
replace haircut_above=0 if country_code=="ZWE"




g sum_default_history =.

forv i=1(1)210 {

egen sum_default_history_`i'=sum(default_history) if id==`i'

replace sum_default_history=sum_default_history_`i' if id==`i'

drop sum_default_history_`i'

}

replace sum_default_history =. if default_history==.


list id sum_default_history if sum_default_history==0
gen d_default_history=.
replace d_default_history =0 if sum_default_history<1
replace d_default_history =1 if sum_default_history>0 & sum_default_history~=.

sum sum_default_history d_default_history

*drop sum_default_history


g sum_imf_prog =.

forv i=1(1)210 {

egen sum_imf_prog_`i'=sum(imf_prog) if id==`i'

replace sum_imf_prog=sum_imf_prog_`i' if id==`i'

drop sum_imf_prog_`i'

}

replace sum_imf_prog =. if imf_prog==.



sum yeconomicriskrating 
gen d_eco_risk=.
replace d_eco_risk=0 if yeconomicriskrating<33.66 & yeconomicriskrating~=.
replace d_eco_risk=1 if yeconomicriskrating>=33.66 & yeconomicriskrating~=.
sum yeconomicriskrating d_eco_risk

sum yfinancialriskrating  
gen d_fin_risk=.
replace d_fin_risk=0 if yfinancialriskrating <34.43 & yfinancialriskrating ~=.
replace d_fin_risk=1 if yfinancialriskrating >=34.43 & yfinancialriskrating ~=.
sum yfinancialriskrating  d_fin_risk

sum ypoliticalriskrating  
gen d_pol_risk=.
replace d_pol_risk=0 if ypoliticalriskrating <64.11 & ypoliticalriskrating ~=.
replace d_pol_risk=1 if ypoliticalriskrating >=64.11 & ypoliticalriskrating ~=.
sum ypoliticalriskrating  d_pol_risk




*model

*keep data of interest

keep if mkt_reentry~=.
keep if  mkt_reentry~=0
keep if _end_r==1

sort id
by id: gen event_r=_n

replace crisis_tally=1 if crisis_tally>=1

sum dur_mkt_reentry censor_r event_r dur_prev_x

*list
tab dur_mkt_reentry censor_r
list dur_mkt_reentry censor_r id

***stset the data for duration analysis***
***and descriptive statistics***

sum dur_mkt_reentry censor_r event_r dur_prev_x oecd ///
 apac latin middle africa europe northamerica
sum dur_mkt_reentry if oecd==0
sum dur_mkt_reentry if oecd==1

****************************************************************
*Simple Weibull: h(t)= gamma*p*t^(p-1)*
****************************************************************


stset dur_mkt_reentry, failure(censor_r)
des dur_mkt_reentry censor_r event_r dur_prev_x
sum dur_mkt_reentry censor_r event_r dur_prev_x
list dur_mkt_reentry censor_r event_r dur_prev_x id
sts list
stsum
tab dur_mkt_reentry censor_r


ltable dur_mkt_reentry censor_r, survival noadjust ci 

*sort id
*sort dur_mkt_reentry
*by dur_mkt_reentry: sum id

*Table 3
******
streg, dist(weibull) nohr vce(cluster id)
estat ic
*constant "gamma"
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2




*regional and decades effects
*****************************
streg apac latin middle africa europe dec70 dec80 dec90, dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2


*regressors
**************

streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_r dur_prev_x, ///
 dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2


streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_r dur_prev_x d_default_history imf_prog larger_countries, ///
 dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2


streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk, ///
 dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])

nlcom exp(_b[/ln_p])-1
nlcom exp(_b[/ln_p])-2
test _b[/ln_p]=ln2
nlcom _b[/ln_p]-ln2

 

*change-points
*Table 4

gen ddur9=0
replace ddur9=1 if dur_mkt_reentry>=9

streg ddur9, dist(weibull) nohr vce(cluster id)
estat ic
nlcom exp(_b[_cons])
nlcom _b[p]-1
nlcom _b[p]-2

streg apac latin middle africa europe dec70 dec80 dec90 ///
 event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk, ///
 dist(weibull) frailty(invgaussian) nohr vce(cluster id)

************

program define my_weibull_x
	version 9
	args lnf theta1 theta2 theta3
	quietly replace `lnf' = $ML_y2*((1-ddur9)* ///
	ln(`theta3'/$ML_y1)+ddur9*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9)))) + ///
	(1-ddur9)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur9*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9)))) - ///
	exp((1-ddur9)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur9*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9))))
end


*1.basic
ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p, vce(cluster id)
ml maximize
estat ic

nlcom _b[/eq1]-_b[/eq2]
nlcom ln(_b[/eq1])
nlcom ln(_b[/eq2])
nlcom ln(_b[/eq1])-ln(_b[/eq2])
nlcom (_b[/eq1])^(_b[/p])
nlcom (_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(9))/(ln(_b[/eq2])+ln(9))))
nlcom (_b[/eq1])^(_b[/p])-(_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(9))/(ln(_b[/eq2])+ln(9))))
nlcom ln((_b[/eq1])^(_b[/p]))
nlcom ln((_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(9))/(ln(_b[/eq2])+ln(9)))))
nlcom (_b[/eq2])^(_b[/p]*((ln(_b[/eq1])+ ///
ln(9))/(ln(_b[/eq2])+ln(9)))) - (_b[/eq1])^(_b[/p])
nlcom _b[/p]-1
nlcom _b[/p]-2
nlcom ln(_b[/p])
nlcom ln(_b[/p])-ln2
nlcom 1/_b[/p]

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-1
nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-2
nlcom ln(_b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9))))
nlcom ln(_b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9))))-ln(2)

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]

nlcom ln(_b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9))))-ln(_b[/p])

nlcom _b[/p]*(((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-1)

nlcom ((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(1o)))-1

program drop my_weibull_x


**with regressors

program define my_weibull_x
	version 9
	args lnf theta1 theta2 theta3 theta4
	quietly replace `lnf' = $ML_y2*(`theta4'+(1-ddur9)* ///
	ln(`theta3'/$ML_y1)+ddur9*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9)))) + ///
	(1-ddur9)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur9*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9)))) - ///
	exp(`theta4'+(1-ddur9)*`theta3'*ln(`theta1'*$ML_y1) + ///
	ddur9*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9))))
end




ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]




*intermedium resuts chg point
*****************************

*market re-entry


gen ddur9=0
replace ddur9=1 if dur_mkt_reentry>=9


program drop my_weibull_x


program define my_weibull_x
	version 9
	args lnf theta1 theta2 theta3 theta4
	quietly replace `lnf' = $ML_y2*(`theta4'+(1-ddur9)* ///
	ln(`theta3'/$ML_y1)+ddur9*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9)))) + ///
	(1-ddur9)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur9*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9)))) - ///
	exp(`theta4'+(1-ddur9)*`theta3'*ln(`theta1'*$ML_y1) + ///
	ddur9*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*9))/(ln(`theta2'*9))))
end




ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]

outreg2 using table_rregm, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]

outreg2 using table_rregm, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append



ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]

outreg2 using table_rregm, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


*********
*********
*Tables 5 & 6
*sens

ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if id~=47, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if id~=47 & id~=141 & id~=142, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if oecd==0, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out2_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk) if d_default_history~=0, ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]

outreg2 using table_out2_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x lenght_above imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out3_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x haircut_above imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out3_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk d_bank_crises), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out4_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk crisis_tally), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]

outreg2 using table_out4_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append


ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk d_cap100), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out4_r, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append





ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk d_banking), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(9))/(ln(_b[/eq2])+ln(9)))-_b[/p]


outreg2 using table_out4_bkr, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(ll r2_p) word append





outreg2 using table_cpr, ctitle(coeff) bdec(4) sdec(4) tdec(4) rdec(4) alpha (.01, .05, .1) e(N_s ll ll_0 SBIC LRI) word append




******************************************************************
******************************************************************

* experiments for figure 2

gen ddur16=0
replace ddur16=1 if dur_mkt_reentry>=16

program drop my_weibull_x


program define my_weibull_x
	version 11
	args lnf theta1 theta2 theta3 theta4
	quietly replace `lnf' = $ML_y2*(`theta4'+(1-ddur16)* ///
	ln(`theta3'/$ML_y1)+ddur16*ln((`theta3'/$ML_y1)* ///
	((ln(`theta1'*16))/(ln(`theta2'*16)))) + ///
	(1-ddur16)*`theta3'*ln(`theta1'*$ML_y1)+ ///
	ddur16*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*16))/(ln(`theta2'*16)))) - ///
	exp(`theta4'+(1-ddur16)*`theta3'*ln(`theta1'*$ML_y1) + ///
	ddur16*`theta3'*ln(`theta2'*$ML_y1)* ///
	((ln(`theta1'*16))/(ln(`theta2'*16))))
end




ml model lf my_weibull_x (dur_mkt_reentry censor_r = ) ///
	(dur_mkt_reentry censor_r = ) /p (dur_mkt_reentry censor_r = ///
	apac latin middle africa europe dec70 dec80 dec90 ///
	event_r dur_prev_x d_default_history imf_prog larger_countries d_eco_risk d_fin_risk d_pol_risk), ///
	vce(cluster id) tech(bfgs)
ml maximize
estat ic

nlcom _b[/p]*((ln(_b[/eq1])+ln(16))/(ln(_b[/eq2])+ln(16)))

nlcom _b[/p]*((ln(_b[/eq1])+ln(16))/(ln(_b[/eq2])+ln(16)))-_b[/p]


*Figure 1
ltable dur_mkt_reentry censor_r, graph ///
					     survival noadjust ///
					     title("Survival function: market re-entry") ///
					     xtitle("Survival time") ///
					     xtick(0(1)45) xlabel(0(5)45) ///
					     ylabel(0(0.25)1) ci




